/*

This file only has a main function
Include KVClientLibrary.c to use interfaces to make GET, PUT, DELETE requests

PA4 instructions:
The client is a separate process that will first establish a connection with the server, and then
send GET , PUT , and DELETE requests to the server process. It will have a main and use the
client library interfaces to do the actual operations.

*/
#define MAX 80 
#define PORT 8000 
#define SA struct sockaddr 
#include "KVClientLibrary.c"
struct message* requestMessage;
void func(int sockfd,struct message* requestMessage) 
{ 
    char buff[MAX]; 
    int n=0; 
    for (;;) { 
        bzero(buff, sizeof(buff)); 
        if(1)
        {
            n++;
            printf("[Message sent to server]\n[[Status:%c]\n[Key:%s]\n[Value:%s]]\n",requestMessage->status,requestMessage->key,requestMessage->value);
            write(sockfd, requestMessage, sizeof(struct message)); 
            sleep(2);
        }  
    } 
} 
int main(int argc, char const *argv[]) 
{ 
    int sock = 0, valread; 
    struct sockaddr_in serv_addr; 
    char *hello = "Hello from client"; 
    char buffer[1024] = {0}; 
    if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) 
    { 
        printf("\n Socket creation error \n"); 
        return -1; 
    } 
   
    serv_addr.sin_family = AF_INET; 
    serv_addr.sin_port = htons(PORT); 
       
    // Convert IPv4 and IPv6 addresses from text to binary form 
    if(inet_pton(AF_INET, "127.0.0.1", &serv_addr.sin_addr)<=0)  
    { 
        printf("\nInvalid address/ Address not supported \n"); 
        return -1; 
    } 
   
    if (connect(sock, (struct sockaddr *)&serv_addr, sizeof(serv_addr)) < 0) 
    { 
        printf("\nConnection Failed \n"); 
        return -1; 
    } 
    char key[256]="abc";
    char value[256]="cde";
    char error[256];
    printf("%d",(int)put(sock,key, value,error));
    printf("%d",(int)del(sock,key,error));
    printf("%d",(int)get(sock,key, value,error));
  
    return 0; 
} 