#include<stdio.h>
#include <string.h>
#include <stdlib.h>
#include "KVMessageFormat.h"
struct message* get(char m,char *key)
{
    if(!m || key==NULL )
    {
        printf("Invalid parameters in get()");
        return NULL;
    }
    struct message *request= malloc(sizeof(struct message));
    request->status=m;
    memcpy(request->key,key,256); //copied the complete key
    if(strlen(request->key)<256)
    {
        request->key[strlen(request->key)]='\0';
    }
    request->value[0]='\0';
    return request;
}
struct message* put(char m,char *key,char *value)
{
    if(!m || (key==NULL && value==NULL))
    {
        printf("Invalid parameters in put()");
        return NULL;
    }

    struct message *request= malloc(sizeof(struct message));
    request->status=m;
    memcpy(request->key,key,256); //copied the complete key
    if(strlen(request->key)<256)
    {
        request->key[strlen(request->key)]='\0';
    }

    memcpy(request->value,value,256); //copied the complete value
    if(strlen(request->key)<256) //to pad with \0
    {
        request->key[strlen(request->value)]='\0';
    }
    
    return request;

}
struct message *del(char m,char *key){
    if(!m || key==NULL )
    {
        printf("Invalid parameters in del()");
        return NULL;
    }
    struct message *request= malloc(sizeof(struct message));
    request->status=m;
    memcpy(request->key,key,256); //copied the complete key
    if(strlen(request->key)<256)
    {
        request->key[strlen(request->key)]='\0';
    }
    request->value[0]='\0';
    return request;
}

struct message *request(char status,char* key,char* value)
{
      if(!status ||(key==NULL && value==NULL) )
    {
        printf("Invalid parameters in request()");
        return NULL;
    }
    struct message *requestMessage= malloc(sizeof(struct message));
    requestMessage->status=status;

    memcpy(requestMessage->key,key,256); //copied the complete key

    if(strlen(requestMessage->key)<256)
    {
        requestMessage->key[strlen(requestMessage->key)]='\0';
    }
    if(value!=NULL)
    {
        memcpy(requestMessage->value,value,256); //copied the complete value
    }
   
    if(strlen(requestMessage->value)<256) //to pad with \0
    {
        requestMessage->value[strlen(requestMessage->value)]='\0';
    }
    printf("[Message Generated at Client]\n[[Status:%c]\n[Key:%s]\n[Value:%s]]",requestMessage->status,requestMessage->key,requestMessage->value);
    return requestMessage;
}
void main()
{
    char message[256];
    for(int i=0;i<30;i++)
    {
        message[i]='a';
    }
    message[sizeof(message)]='\0';
    request('2',message,message);   
    char c ='2';
    int status=(int)c;
    
    printf("%d",status);

    //creating a message
}